<?php defined('SYSPATH') or die('No direct script access.');

class Model_CourseWork extends Model {

    /**
     * Add new discipline.
     *
     * @param $data
     * <li>teacher int teacher id</li>
     * <li>grade int 1-7</li>
     * <li>subject int subject id</li>
     * <li>type string <tt>scientific</tt> or <tt>disciplinary</tt></li>
     * <li>faculty int faculty id</li>
     * @return int  discipline id
     */
    public static function create(array $data) {
        $map = [
            'scientific' => 'scientific_coursework',
            'disciplinary' => 'disciplinary_coursework',
        ];

        $sql = "SELECT `Discipline_Create`(:teacher, :grade, :subject, 'grading_credit', 0, 0, 0, :faculty, :semester, :type) AS `Num`;";

        return $result = DB::query(Database::SELECT, $sql)
            ->parameters([
                ':teacher' => $data['teacher'],
                ':subject' => $data['subject'],
                ':faculty' => $data['faculty'],
                ':grade' => $data['grade'],
                ':type' => $map[$data['type']],
                ':semester' => $data['semester'],
            ])->execute()[0]['Num'];
    }
}